//
//   deminor.h
//
//   Copyright 2010 Glibert axel
//
//   This file is part of Deminor.
//
//   Deminor is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Deminor is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Deminor.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef __DEMINOR_H__
#define __DEMINOR_H__

#define T_GRILLE (10)
#define NBR_CASES T_GRILLE*T_GRILLE
#define TILE (20)
#define BATTERY_W (19)
#define BATTERY_H (10)

#define IMG_BACKGROUND (0)
#define IMG_TILESET    (1)
#define IMG_NAME	   (2)
#define IMG_AUTHOR 	   (3)
#define IMG_MINES 	   (4)
#define IMG_FLAGLEFT   (5)
#define IMG_ENDMESSAGE (6)
#define IMG_TOPSCORE   (7)
#define IMG_SCORE1     (8)
#define IMG_SCORE2     (9)
#define IMG_SCORE3     (10)
#define IMG_BATTERY    (11)

typedef struct
{
    bool flag;
    bool hidden;
    Uint8 contain;
} cellule;

typedef struct
{
    Uint8 x, y;
} Coord;

typedef struct
{
    bool win;
    bool end;
    bool gamesaved;
    Uint8 cellulesDevoilees;
    Uint8 reserveFlags;
} GameState;

enum VAL_CELL
{
    NONE   , // 0
    UN     , // 1 
    DEUX   , // 2 
    TROIS  , // 3 
    QUATRE , // 4 
    CINQ   , // 5 
    SIX    , // 6
    SEPT   , // 7 
    HUIT   , // 8 
    BOMB   , // 9 
    BOOM   , // 10
    CLOSE  , // 11
    FLAG   , // 12
    BADFLAG, // 13
    DEMINED, // 14
    SELECTOR // 15
};

void init_game(const int taille, cellule grille[][taille], Uint32 *nbrBomb, GameState *state, Uint32 *offset, Uint32 ellapse, Uint32 score[]);
void affich_grille(const int taille, cellule grille[][taille]);
void genere_grille(const int taille, cellule grille[][taille], int n);
Uint8 cpt_nbr_bomb(const int taille, cellule grille[][taille], const int x, const int y);
void increment_voisin(const int taille, cellule grille[][taille], const int x, const int y);
void update_selector(Coord *actualpos, Input *in);
void tester_cellule(const int taille, cellule grille[][taille], Coord *actualpos,  GameState *state, Uint32 nbrBomb);
void devoile_cellule(const int taille, cellule grille[][taille], Coord *actualpos,  GameState *state);
void place_flag(const int taille, cellule grille[][taille], Coord *actualpos,  GameState *state);
void open_all(const int taille, cellule grille[][taille]);
void save_score(GameState *state, Uint32 newScore, Uint32 score[], Uint32 nbrBomb);

#endif
