/*
    File name: easywiz.h
    Author: axelorque
    Date: 15/03/2010
    Last update: 04/09/2010
    
    Contain prototypes and definition's structures to make applications on 
    GP2X Wiz.
*/
#ifndef __EASYWIZ_H__
#define __EASYWIZ_H__
#define EASYWIZ_MAJOR_VERSION    (2)
#define EASYWIZ_MINOR_VERSION    (3)
#define EASYWIZ_PATCHLEVEL       (9)

#define WIZ_WIDTH (320)
#define WIZ_HEIGHT (240)
#define WIZ_DEPTH (16)

enum MAP_KEY
{
	VK_UP         , // 0
	VK_UP_LEFT    , // 1
	VK_LEFT       , // 2
	VK_DOWN_LEFT  , // 3
	VK_DOWN       , // 4
	VK_DOWN_RIGHT , // 5
	VK_RIGHT      , // 6
	VK_UP_RIGHT   , // 7
	VK_START      , // 8
	VK_SELECT     , // 9
	VK_FL         , // 10
	VK_FR         , // 11
	VK_FA         , // 12
	VK_FB         , // 13
	VK_FX         , // 14
	VK_FY         , // 15
	VK_VOL_UP     , // 16
	VK_VOL_DOWN   , // 17
	VK_TAT          // 18 I don't know what is it???? ->nbr total de bouttons ??
};

/* To use bool type in C */
#ifndef __cplusplus
typedef SDL_bool bool;

enum
{
    false = SDL_FALSE ,
    true = SDL_TRUE   
};
#endif

#define MAX_IMAGES (16)

typedef struct 
{
    SDL_Surface *img;
} wiz_image;

typedef struct 
{
    char key[VK_TAT + 1];
    char mousebuttons[1];
    int mousex, mousey, mousexrel, mouseyrel;
} Input;

/* Init & Info Functions */
bool wiz_Init(void);
static void wiz_Terminate(void);
void wiz_SplashScreen(const char *name, Uint32 time);
unsigned short wiz_GetBatteryState(void);
/* Input-Output Function */
bool wiz_UpdateInput(Input *in); //modification pour Deminor (elle est intressante pour teindre l'cran lors d'inactivit)
void wiz_UpdateScreen(void);
void wiz_framerate(Uint32 fps);
bool wiz_SetScreenOnOff(bool value);
/* Image Functions */
bool wiz_LoadImage(Uint8 n, const char *name);
bool wiz_LoadSurface(Uint8 n, SDL_Surface *tmp);
void wiz_DisplayImage(Uint8 n, int x, int y);
void wiz_DisplayImagePart(Uint8 n, int x, int y, int w, int h, int posx, int posy);
static void wiz_FreeImage(void);
void wiz_Screenshot(void);
/* Text Functions */
bool wiz_LoadTextSurface(Uint8 n, const char *text);

#endif

